var mongoose = require('mongoose');
var promise = require('promise');
mongoose.Promise = promise;

var db = {};
db.connect = function(contratante, aplicacao) {

    if (!global.DicionarioConexoes) {

        global.DicionarioConexoes = [];

        contratante.contratantesIds.forEach(function(contratanteId) {

            var conexao = {};
            var connection = contratante.getDataBaseConnection(contratanteId, 'MONGODB', aplicacao);
            var url = 'mongodb://' + connection.Usuario + ':' + connection.Senha + '@' + connection.Servidor + "/" + connection.BancoDeDados;

            conexao.models = [];
            conexao.contratanteId = contratanteId;
            conexao.instancia = mongoose.createConnection(url, { config: { autoIndex: true } }, function(error, teste) {
                if (error) {
                    console.log("Erro ao conectar no MongoDb: " + error);
                    process.exit();
                } else {
                    console.log("MongoDb conectado.");
                }
            });

            global.DicionarioConexoes.push(conexao);

        });
    }
};

db.staticConnect = function(connectionConfig, name) {

    if (!global.DicionarioConexoesEstaticas) {

        global.DicionarioConexoesEstaticas = [];

        var conexao = {};
        var url = 'mongodb://' + connectionConfig.user + ':' + connectionConfig.pass + '@' + connectionConfig.host + ":" + connectionConfig.port + "/" + connectionConfig.database;

        conexao.models = [];
        conexao.name = name;
        conexao.instancia = mongoose.createConnection(url, { config: { autoIndex: true } }, function(error, teste) {
            if (error) {
                console.log("Erro ao conectar no MongoDb: " + error);
                process.exit();
            } else {
                console.log("MongoDb conectado.");
            }
        });

        global.DicionarioConexoesEstaticas.push(conexao);
    }
};

module.exports = db;